#!/usr/bin/env python
# -*- coding: utf-8 -*-
#   KATAMOTZ: Un programa para tratar la dislexia y otros problemas lectores
#   Copyright (C)2010   Autor: Gonzalo Uriarte Gómez.	Email: Txasatonga@yahoo.es
#
#   Este programa es software libre: usted puede redistribuirlo y/o modificarlo 
#   bajo los términos de la Licencia Pública General GNU publicada 
#   por la Fundación para el Software Libre, ya sea la versión 3 
#   de la Licencia, o (a su elección) cualquier versión posterior.
#
#   Este programa se distribuye con la esperanza de que sea útil, pero 
#   SIN GARANTÍA ALGUNA; ni siquiera la garantía implícita 
#   MERCANTIL o de APTITUD PARA UN PROPÓSITO DETERMINADO. 
#   Consulte los detalles de la Licencia Pública General GNU para obtener 
#   una información más detallada. 
#
#   En el archivo leeme.txt que se distribuye con el programa
#   existe una traducción de la Licencia No Oficial Pública General GNU V3 en Español 
#   Para consultar la licencia Oficial on-line en Ingles, consulte <http://www.gnu.org/licenses/>.


import codecs
import wxversion
wxversion.select('2.8')
import wx
import wx.lib.filebrowsebutton
import unicodedata

empezar= False
pausar = False
retraso=5
abrirarchivo_abierto=False
sobrekatamotz_abierto=False
direccion= "/usr/bin/katamotz/"

class texto:
    def __init__(self):
        self.indicelin = 0
        self.lin=[""]
        self.numerolin=0
        self.linsinacentomin=[""]
        self.nombrearchivo=''
        self.listapalabras=[""]
        self.numeropalabras=0
        self.indicepalabras=0
        self.indiceletras=0
        self.fuente=""
        self.desapareciendo=True
        self.sinacentomin2=""
        self.sinacentomin3=""
        self.sinacentomin4=""
        self.sinacentomin5=""
        
    def sinacentomin(self,cadena):
        def normaliza(c):
            return unicodedata.normalize("NFD",c)[0].lower()
        return ''.join(normaliza(c) for c in cadena)




[wxID_MINIFRAME1, wxID_MINIFRAME1STATICBITMAP1, wxID_MINIFRAME1STATICTEXT1, 
 wxID_MINIFRAME1STATICTEXT2, wxID_MINIFRAME1STATICTEXT3, wxBITMAP_TYPE_ANY
] = [wx.NewId() for _init_ctrls in range(6)]

class MiniFrame1(wx.Frame):
    def _init_ctrls(self, MyFrame):
	global direccion
        # generated method, don't edit
        
        wx.Frame.__init__(self, id=wxID_MINIFRAME1, name='', parent=MyFrame,
              pos=wx.Point(280, 154), size=wx.Size(960, 400),
              style=wx.DEFAULT_FRAME_STYLE, title='Sobre Katamotz')

        self.SetBackgroundColour('Green')

        self.SetClientSize(wx.Size(960, 400))
        
        self.staticText1 = wx.StaticText(self,-1,
              u'KATAMOTZ:\n Programa libre y gratuito para el tratamiento de problemas de lectura. \n Autor: Gonzalo Uriarte Gomez  \n Email: txasatonga@yahoo.es\n Copyright(C) 2011',
              (250, 3),(550, 106), style=wx.ALIGN_CENTER)
        self.staticText1.SetFont(wx.Font(10,wx.SWISS,wx.NORMAL,wx.BOLD))
            

        
        self.staticBitmap1 = wx.StaticBitmap(bitmap=wx.Image(direccion+"katamotz_dibujo.jpg").ConvertToBitmap(),
              id=wxID_MINIFRAME1STATICBITMAP1, name='staticBitmap1',
              parent=self, pos=wx.Point(10, 100), size=wx.Size(150, 180), style=0)

    
        self.staticText3 = wx.StaticText(self,-1,
              u' Katamotz: Es un programa libre bajo la versi\xf3n 3 de GNU GLP. Usted puede participar en el programa,\n mejorarlo o adaptarlo a sus necesidades siempre y cuando haga usted mención al autor original y \n el nombre del programa original(pero sin hacerme responsable de los posibles errores). Autor del lince \n del logotipo:Miquel Adroer Llauradó -- http://miquel66.caliu.cat \n\n Este lector le ofrece la posibilidad de marcar letras o palabras con  diferentes colores para poder\n diferenciarlas con mayor facilidad. Puede leer apareciendo o desapareciendo el texto. Usted puede \n utilizar tres tipos de letra: Edelfontmed, Liberation sans y  Liberation mono. Letras gratuitas \n que podr\xe1 descargar de internet. Por \xfaltimo, sepa, que usted mismo/a  podr\xe1 crear los \n ejercicios y  lecturas ad\xe1ptandolos a sus necesidades. Se recomiendan archivos con  extensión \n.txt y es impresincible guardarlos en formato UTF-8.\n\n Para manejar el texto con el teclado,\n Play = Alt+Arriba                   Pausa = Alt+Abajo\n Avanzar = Alt+Derecha          Retrasar = Alt+Izquierda\n Un Saludo!! \n', 
              (170, 100),(720,670),wx.ALIGN_LEFT)
        self.staticText3.SetFont(wx.Font(10,wx.SWISS,wx.NORMAL,wx.NORMAL))

        self.Bind(wx.EVT_CLOSE, self.OnClose)
        
    def OnClose(self,event):
        global sobrekatamotz_abierto
        sobrekatamotz_abierto=False
        event.Skip()

    def __init__(self, parent):
        self._init_ctrls(parent)
        



[wxID_FRAME1, wxID_FRAME1FILEBROWSEBUTTON1, wxID_FRAME1RADIOBUTTON1, 
 wxID_FRAME1RADIOBUTTON2, wxID_FRAME1BUTTON1,wxID_FRAME1BUTTON2
] = [wx.NewId() for _init_ctrls in range(6)]

class Frame1(wx.Frame):
    def _init_ctrls(self, MyFrame):
        # generated method, don't edit
        
        wx.Frame.__init__(self, id=wxID_FRAME1, name='', parent=MyFrame,
              pos=wx.Point(200, 169), size=wx.Size(603, 250),
              style=wx.DEFAULT_FRAME_STYLE, title='Abrir archivo')
        self.SetClientSize(wx.Size(603, 250))
        
        self.fileBrowseButton1 = wx.lib.filebrowsebutton.FileBrowseButton(buttonText='Buscar',
              dialogTitle='Elige archivo', fileMask='*.*',
              id=wxID_FRAME1FILEBROWSEBUTTON1, initialValue='',
              labelText='Archivo a abrir:', parent=self, pos=wx.Point(32, 100),
              size=wx.Size(568, 80), startDirectory='.', style=wx.TAB_TRAVERSAL,
              toolTip='Escribe el nombre de archivo y su ruta o pulsa buscar...')

        self.Etiqueta1=wx.StaticText(self, -1, u"El archivo a abrir tiene que haber sido guardado en formato UTF-8. En Windows es recomendado utilizar Notepad y en Ubuntu se recomienda gedit.",
        (50, 50),(520,470),wx.ALIGN_LEFT)
        
        self.button1 = wx.Button(id=wxID_FRAME1BUTTON1, label='Abrir',name='button1', parent=self, pos=wx.Point(504, 200),size=wx.Size(85, 33), style=0)

        self.button1.Bind(wx.EVT_BUTTON, self.OnButton1Button,id=wxID_FRAME1BUTTON1)

        self.button2 = wx.Button(id=wxID_FRAME1BUTTON2, label='Cancelar',name='button2', parent=self, pos=wx.Point(404, 200),size=wx.Size(85, 33), style=0)

        self.button2.Bind(wx.EVT_BUTTON, self.oncancelar)
        
        self.Bind(wx.EVT_CLOSE, self.OnClose)

    def __init__(self, parent):
        self._init_ctrls(parent)

    def OnClose(self,event):
        global abrirarchivo_abierto
        abrirarchivo_abierto=False
        event.Skip()
        
    def oncancelar(self,event):
        global abrirarchivo_abierto
        abrirarchivo_abierto=False
        self.Destroy()
        event.Skip()
        

    def OnButton1Button (self,event):
        global abrirarchivo_abierto  #Variable booleana para saber si el formulario abrirarchivo esta abierto
        abierto = True
        try:
            archivo = codecs.open(self.fileBrowseButton1.GetValue(),'r','utf-8')
        except:
            m=wx.MessageBox("No se puede abrir Archivo","Info")
            abierto=False
            abrirarchivo_abierto= False
            frameprincipal.text_ctrl_1.SetFocus()
            self.Destroy()
        Texto.indicelin=0
        Texto.lin=[""]
        if abierto:
            Terminado=False
            while not Terminado:
                try:
                    estalinea = archivo.readline()

                except:
                    m=wx.MessageBox("Error al leer archivo","Info")
                    Terminado=True
                    abrirarchivo_abierto= False
                    self.Destroy()
                if not estalinea: break
                if estalinea[0] == unicode( codecs.BOM_UTF8, "utf8" ):  #elimina el bom que suelen tener algunos archivos utf8 precisamente para identificarse como utf8
                    estalinea=estalinea[1::]
                Texto.lin[Texto.indicelin]= estalinea
                Texto.linsinacentomin[Texto.indicelin]=Texto.sinacentomin(estalinea)
                Texto.lin.append("")
                Texto.linsinacentomin.append("")
                Texto.indicelin+=1
                
            Texto.numerolin = Texto.indicelin-1
            archivo.close()
            if Texto.numerolin>=0:
                Texto.indicelin=0
                Texto.indiceletras=0
                Texto.indicepalabras=0
                Texto.listapalabras=Texto.lin[Texto.indicelin].split(" ")
                Texto.numeropalabras=len(Texto.listapalabras)
                frameprincipal.text_ctrl_1.SetInsertionPoint(0)
                frameprincipal.text_ctrl_1.SetValue(Texto.lin[Texto.indicelin])
                frameprincipal.refrescarpagina(0,Texto.indiceletras,len(Texto.lin[Texto.indicelin]))
                frameprincipal.SetTitle("Katamotz: "+self.fileBrowseButton1.GetValue())
            else: 
                m=wx.MessageBox("Lo siento. Este archivo se encuentra vacio","Info")
        
        frameprincipal.text_ctrl_1.SetFocus()
        abrirarchivo_abierto= False
        self.Destroy()
        event.Skip()
        
    def OnRadioButton2Radiobutton(self, event):
        self.fileBrowseButton1.Destroy()
        self.fileBrowseButton1 = wx.lib.filebrowsebutton.FileBrowseButton(buttonText='Buscar',
              dialogTitle='Elige archivo', fileMask='*.*',
              id=wxID_FRAME1FILEBROWSEBUTTON1, initialValue='',
              labelText='Archivo a abrir:', parent=self, pos=wx.Point(32, 224),
              size=wx.Size(568, 80), startDirectory='.', style=wx.TAB_TRAVERSAL,
              toolTip='Escribe el nombre de archivo o pulsa buscar...')
        event.Skip()
        


# begin wxGlade: extracode
# end wxGlade
[ wxID_FRAME1TEXTCTRL1] = [wx.NewId() for _init_ctrls in range(1)]

class MyFrame(wx.Frame):
    def __init__(self, *args, **kwds):
	global direccion
        # begin wxGlade: MyFrame.__init__
        kwds["style"] = wx.DEFAULT_FRAME_STYLE
        wx.Frame.__init__(self, *args, **kwds)
        # Menu Bar
        self.frame_1_menubar = wx.MenuBar()
        self.archivo = wx.Menu()
        self.abrirarchivo = wx.MenuItem(self.archivo, wx.NewId(), "Abrir archivo", "", wx.ITEM_NORMAL)
        self.archivo.AppendItem(self.abrirarchivo)
        self.frame_1_menubar.Append(self.archivo, "Archivo")
        
        self.opciones = wx.Menu()
        self.tipoletra = wx.Menu()
        
        self.arial = wx.MenuItem(self.tipoletra, wx.NewId(), "Arial", "", wx.ITEM_RADIO)
        self.tipoletra.AppendItem(self.arial)
        self.ligada = wx.MenuItem(self.tipoletra, wx.NewId(), "Ligada", "", wx.ITEM_RADIO)
        self.tipoletra.AppendItem(self.ligada)
        self.mono = wx.MenuItem(self.tipoletra, wx.NewId(), "Mono", "", wx.ITEM_RADIO)
        self.tipoletra.AppendItem(self.mono)
        self.opciones.AppendMenu(wx.NewId(),"tipo letra",self.tipoletra,"")
        self.modolectura = wx.Menu()
        self.desapareciendo = wx.MenuItem(self.modolectura, wx.NewId(), "Desapareciendo", "", wx.ITEM_RADIO)
        self.modolectura.AppendItem(self.desapareciendo)
        self.apareciendo = wx.MenuItem(self.modolectura, wx.NewId(), "Apareciendo", "", wx.ITEM_RADIO)
        self.modolectura.AppendItem(self.apareciendo)
        self.opciones.AppendMenu(wx.NewId(), "Modo lectura", self.modolectura, "")
        self.frame_1_menubar.Append(self.opciones, "Opciones") 
        self.ayuda = wx.Menu()
        self.sobrekatamotz= wx.MenuItem(self.ayuda, wx.NewId(), "Sobre Katamotz", "", wx.ITEM_NORMAL)
        self.ayuda.AppendItem(self.sobrekatamotz)
        self.frame_1_menubar.Append(self.ayuda, "Ayuda")
        self.SetMenuBar(self.frame_1_menubar)

        # Menu Bar end
        
        self.panel_6 = wx.Panel(self, -1)
        self.label_1 = wx.StaticText(self, -1, u"Tamaño\nde letra")
        self.slider_1 = wx.Slider(self, -1, 0, 0, 10, style=wx.SL_HORIZONTAL|wx.SL_LABELS)
        self.panel_7 = wx.Panel(self, -1)
        self.label_2 = wx.StaticText(self, -1, "Velocidad")
        self.slider_2 = wx.Slider(self, -1, 0, 0, 100, style=wx.SL_HORIZONTAL|wx.SL_LABELS)
        self.panel_8 = wx.Panel(self, -1)
        self.bitmap_button_3 = wx.BitmapButton(self, -1, wx.Bitmap(direccion+"katamotz_atras.jpg", wx.BITMAP_TYPE_ANY))
        self.panel_9 = wx.Panel(self, -1)
        self.bitmap_button_2 = wx.BitmapButton(self, -1, wx.Bitmap(direccion+"katamotz_play.jpg", wx.BITMAP_TYPE_ANY))
        self.panel_10 = wx.Panel(self, -1)
        self.bitmap_button_4 = wx.BitmapButton(self, -1, wx.Bitmap(direccion+"katamotz_pause.jpg", wx.BITMAP_TYPE_ANY))
        self.panel_11 = wx.Panel(self, -1)
        self.bitmap_button_5 = wx.BitmapButton(self, -1, wx.Bitmap(direccion+"katamotz_stop.jpg", wx.BITMAP_TYPE_ANY))
        self.panel_12 = wx.Panel(self, -1)
        self.panel_13 = wx.Panel(self, -1)
        self.bitmap_button_6 = wx.BitmapButton(self, -1, wx.Bitmap(direccion+"katamotz_adelante.jpg", wx.BITMAP_TYPE_ANY))
        self.text_ctrl_1 = wx.TextCtrl(id=wxID_FRAME1TEXTCTRL1, name='text_ctrl_1',parent=self, pos=wx.Point(488, 24), size=wx.Size(160, 152),style=wx.TE_MULTILINE|wx.TE_READONLY|wx.TE_RICH2, value='')
        self.panel_1 = wx.Panel(self, -1)
        self.text_ctrl_2 = wx.TextCtrl(self, -1, "")
        self.panel_2 = wx.Panel(self, -1)
        self.text_ctrl_3 = wx.TextCtrl(self, -1, "")
        self.panel_3 = wx.Panel(self, -1)
        self.text_ctrl_4 = wx.TextCtrl(self, -1, "")
        self.panel_4 = wx.Panel(self, -1)
        self.text_ctrl_5 = wx.TextCtrl(self, -1, "")
        self.panel_5 = wx.Panel(self, -1)
        self.__set_properties()
        self.__do_layout()

        self.Bind(wx.EVT_MENU, self.subabrirarchivo, self.abrirarchivo)
        self.Bind(wx.EVT_MENU, self.subarial, self.arial)
        self.Bind(wx.EVT_MENU, self.subligada, self.ligada)
        self.Bind(wx.EVT_MENU, self.submono, self.mono)
        self.Bind(wx.EVT_MENU, self.subapareciendo, self.apareciendo)
        self.Bind(wx.EVT_MENU, self.subdesapareciendo, self.desapareciendo)
        self.Bind(wx.EVT_MENU, self.subsobrekatamotz, self.sobrekatamotz)

        self.Bind(wx.EVT_CLOSE, self.OnClose)
        
        self.Bind(wx.EVT_KEY_DOWN,self.subtecla)
        self.text_ctrl_1.Bind(wx.EVT_KEY_DOWN,self.subtecla)
        self.text_ctrl_2.Bind(wx.EVT_KEY_DOWN,self.subtecla)
        self.text_ctrl_3.Bind(wx.EVT_KEY_DOWN,self.subtecla)
        self.text_ctrl_4.Bind(wx.EVT_KEY_DOWN,self.subtecla)
        self.text_ctrl_5.Bind(wx.EVT_KEY_DOWN,self.subtecla)
        self.slider_1.Bind(wx.EVT_KEY_DOWN,self.subtecla)
        self.slider_2.Bind(wx.EVT_KEY_DOWN,self.subtecla)
        self.bitmap_button_2.Bind(wx.EVT_KEY_DOWN,self.subtecla)
        self.bitmap_button_3.Bind(wx.EVT_KEY_DOWN,self.subtecla)
        self.bitmap_button_4.Bind(wx.EVT_KEY_DOWN,self.subtecla)
        self.bitmap_button_5.Bind(wx.EVT_KEY_DOWN,self.subtecla)
        self.bitmap_button_6.Bind(wx.EVT_KEY_DOWN,self.subtecla)
            
        self.Bind(wx.EVT_COMMAND_SCROLL, self.subtamanoletra, self.slider_1)
        self.Bind(wx.EVT_COMMAND_SCROLL, self.subvelocidad, self.slider_2)
        self.Bind(wx.EVT_BUTTON, self.onatras, self.bitmap_button_3)
        self.Bind(wx.EVT_BUTTON, self.onplay, self.bitmap_button_2)
        self.Bind(wx.EVT_BUTTON, self.onpause, self.bitmap_button_4)
        self.Bind(wx.EVT_BUTTON, self.onstop, self.bitmap_button_5)
        self.Bind(wx.EVT_BUTTON, self.ondelante, self.bitmap_button_6)        
        self.Bind(wx.EVT_TEXT,self.subnormalizarbusquedas, self.text_ctrl_2)
        self.Bind(wx.EVT_TEXT,self.subnormalizarbusquedas, self.text_ctrl_3)
        self.Bind(wx.EVT_TEXT,self.subnormalizarbusquedas, self.text_ctrl_4)
        self.Bind(wx.EVT_TEXT,self.subnormalizarbusquedas, self.text_ctrl_5)
        
        # end wxGlade
        # timer actibatu
        self.timerID = wx.NewId()
        self.timer=wx.Timer(self,self.timerID)
        wx.EVT_TIMER (self,self.timerID,self.onTimer)
        #timer actibatuta
    
    
    def __set_properties(self):
        # begin wxGlade: MyFrame.__set_properties
        self.SetTitle("Katamotz")
        self.SetSize((1142, 509))
        self.SetBackgroundColour(wx.Colour(220, 218, 213))
        self.SetForegroundColour(wx.Colour(0, 0, 0))
        self.panel_1.SetBackgroundColour(wx.Colour(220, 218, 213))
        self.panel_2.SetBackgroundColour(wx.Colour(220, 218, 213))
        self.panel_3.SetBackgroundColour(wx.Colour(220, 218, 213))
        self.panel_4.SetBackgroundColour(wx.Colour(220, 218, 213))
        self.panel_5.SetBackgroundColour(wx.Colour(220, 218, 213))
        self.panel_6.SetBackgroundColour(wx.Colour(220, 218, 213))
        self.panel_7.SetBackgroundColour(wx.Colour(220, 218, 213))
        self.panel_8.SetBackgroundColour(wx.Colour(220, 218, 213))
        self.panel_9.SetBackgroundColour(wx.Colour(220, 218, 213))
        self.panel_10.SetBackgroundColour(wx.Colour(220, 218, 213))
        self.panel_11.SetBackgroundColour(wx.Colour(220, 218, 213))
        self.panel_12.SetBackgroundColour(wx.Colour(220, 218, 213))
        self.panel_13.SetBackgroundColour(wx.Colour(220, 218, 213))
        self.SetFont(wx.Font(8, wx.DEFAULT, wx.NORMAL, wx.NORMAL, 0, "Liberation Sans"))
        self.slider_1.SetMinSize((237, 43))
        self.slider_2.SetMinSize((237, 43))
        self.bitmap_button_3.SetMinSize((60, 60))
        self.bitmap_button_3.SetBackgroundColour(wx.Colour(220, 218, 213))
        self.bitmap_button_3.SetForegroundColour(wx.Colour(0, 0, 0))
        self.bitmap_button_3.SetFont(wx.Font(8, wx.DEFAULT, wx.NORMAL, wx.NORMAL, 0, "Liberation Sans"))
        self.bitmap_button_2.SetMinSize((60, 60))
        self.bitmap_button_2.SetBackgroundColour(wx.Colour(220, 218, 213))
        self.bitmap_button_2.SetForegroundColour(wx.Colour(0, 0, 0))
        self.bitmap_button_2.SetFont(wx.Font(8, wx.DEFAULT, wx.NORMAL, wx.NORMAL, 0, "Liberation Sans"))
        self.bitmap_button_4.SetSize(self.bitmap_button_4.GetBestSize())
        self.bitmap_button_5.SetSize(self.bitmap_button_5.GetBestSize())
        self.text_ctrl_1.SetMinSize((780, 329))
        self.text_ctrl_1.SetBackgroundColour(wx.Colour(255, 255, 255))
        self.text_ctrl_1.SetForegroundColour(wx.Colour(0, 0, 0))
        self.text_ctrl_1.SetFont(wx.Font(20, wx.DEFAULT, wx.NORMAL, wx.NORMAL, 0, "Liberation Sans"))
        self.text_ctrl_2.SetMinSize((155, 29))
        self.text_ctrl_2.SetBackgroundColour("red")
        self.text_ctrl_2.SetForegroundColour(wx.Colour(0, 0, 0))
        self.text_ctrl_2.SetFont(wx.Font(14, wx.DEFAULT, wx.NORMAL, wx.BOLD, 0, "Liberation Sans"))
        self.text_ctrl_3.SetMinSize((155, 29))
        self.text_ctrl_3.SetBackgroundColour(wx.Colour(100,100,100))
        self.text_ctrl_3.SetForegroundColour(wx.Colour(0, 0, 0))
        self.text_ctrl_3.SetFont(wx.Font(14, wx.DEFAULT, wx.NORMAL, wx.BOLD, 0, "Liberation Sans"))
        self.text_ctrl_4.SetMinSize((155, 29))
        self.text_ctrl_4.SetBackgroundColour("green")
        self.text_ctrl_4.SetForegroundColour(wx.Colour(0, 0, 0))
        self.text_ctrl_4.SetFont(wx.Font(14, wx.DEFAULT, wx.NORMAL, wx.BOLD, 0, "Liberation Sans"))
        self.text_ctrl_5.SetMinSize((155, 29))
        self.text_ctrl_5.SetBackgroundColour("brown")
        self.text_ctrl_5.SetForegroundColour(wx.Colour(0, 0, 0))
        self.text_ctrl_5.SetFont(wx.Font(14, wx.DEFAULT, wx.NORMAL, wx.BOLD, 0, "Liberation Sans"))
        # end wxGlade

    def __do_layout(self):
        # begin wxGlade: MyFrame.__do_layout
        sizer_1 = wx.BoxSizer(wx.VERTICAL)
        sizer_3 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_2 = wx.BoxSizer(wx.HORIZONTAL)
        
        sizer_2.Add(self.panel_6, 1, wx.EXPAND, 0)
        sizer_2.Add(self.label_1, 0, wx.TOP|wx.ALIGN_CENTER_HORIZONTAL|wx.ALIGN_CENTER_VERTICAL|wx.ADJUST_MINSIZE, 0)
        sizer_2.Add(self.slider_1, 0, wx.ALIGN_CENTER_HORIZONTAL|wx.ALIGN_CENTER_VERTICAL|wx.ADJUST_MINSIZE, 0)
        sizer_2.Add(self.panel_7, 1, wx.EXPAND, 0)
        sizer_2.Add(self.label_2, 0, wx.TOP|wx.ALIGN_CENTER_HORIZONTAL|wx.ALIGN_CENTER_VERTICAL|wx.ADJUST_MINSIZE, 0)
        sizer_2.Add(self.slider_2, 0, wx.ALIGN_CENTER_HORIZONTAL|wx.ALIGN_CENTER_VERTICAL|wx.ADJUST_MINSIZE, 0)
        sizer_2.Add(self.panel_8, 1, wx.EXPAND, 0)
        sizer_2.Add(self.bitmap_button_3, 0, wx.ALIGN_CENTER_HORIZONTAL|wx.ALIGN_CENTER_VERTICAL|wx.ADJUST_MINSIZE, 0)
        sizer_2.Add(self.panel_9, 1, wx.BOTTOM|wx.EXPAND, 0)
        sizer_2.Add(self.bitmap_button_2, 0, wx.ALIGN_CENTER_HORIZONTAL|wx.ALIGN_CENTER_VERTICAL|wx.ADJUST_MINSIZE, 0)
        sizer_2.Add(self.panel_10, 1, wx.EXPAND, 0)
        sizer_2.Add(self.bitmap_button_4, 0, wx.ALIGN_CENTER_HORIZONTAL|wx.ALIGN_CENTER_VERTICAL|wx.ADJUST_MINSIZE, 0)
        sizer_2.Add(self.panel_11, 1, wx.EXPAND, 0)
        sizer_2.Add(self.bitmap_button_5, 0, wx.ALIGN_CENTER_HORIZONTAL|wx.ALIGN_CENTER_VERTICAL|wx.ADJUST_MINSIZE, 0)
        sizer_2.Add(self.panel_12, 1, wx.EXPAND, 0)
        sizer_2.Add(self.bitmap_button_6,0, wx.ALIGN_CENTER_HORIZONTAL|wx.ALIGN_CENTER_VERTICAL|wx.ADJUST_MINSIZE,0)
        
        sizer_1.Add(sizer_2, 1, wx.EXPAND, 0)
        sizer_1.Add(self.text_ctrl_1,0, wx.EXPAND|wx.ADJUST_MINSIZE, 0)
        
        sizer_3.Add(self.panel_1, 1, wx.EXPAND, 0)
        sizer_3.Add(self.text_ctrl_2, 0, wx.ALIGN_CENTER_HORIZONTAL|wx.ALIGN_CENTER_VERTICAL|wx.ADJUST_MINSIZE, 0)
        sizer_3.Add(self.panel_2, 1, wx.EXPAND, 0)
        sizer_3.Add(self.text_ctrl_3, 0, wx.ALIGN_CENTER_HORIZONTAL|wx.ALIGN_CENTER_VERTICAL|wx.ADJUST_MINSIZE, 0)
        sizer_3.Add(self.panel_3, 1, wx.EXPAND, 0)
        sizer_3.Add(self.text_ctrl_4, 0, wx.ALIGN_CENTER_HORIZONTAL|wx.ALIGN_CENTER_VERTICAL|wx.ADJUST_MINSIZE, 0)
        sizer_3.Add(self.panel_4, 1, wx.EXPAND, 0)
        sizer_3.Add(self.text_ctrl_5, 0, wx.ALIGN_CENTER_HORIZONTAL|wx.ALIGN_CENTER_VERTICAL|wx.ADJUST_MINSIZE, 0)
        sizer_3.Add(self.panel_5, 1, wx.EXPAND, 0)
        sizer_1.Add(sizer_3, 1, wx.EXPAND, 0)
        
        self.SetSizer(sizer_1)
        self.Layout()
        # end wxGlade
        

    def subtecla(self,event):
        tecla = event.GetKeyCode()
        if event.AltDown() and tecla==wx.WXK_LEFT: self.onatras(event)
        
        if event.AltDown() and tecla==wx.WXK_RIGHT: self.ondelante(event)
        
        if event.ControlDown():
            self.text_ctrl_1.ShowPosition(Texto.indiceletras)
            
        if event.AltDown() and tecla==wx.WXK_DOWN: 
            self.onpause(event)
            
        if event.AltDown() and tecla==wx.WXK_UP: 
            self.onplay(event)
            pausar=False
            empezar=True
        
        event.Skip()
    
        
    def subsobrekatamotz(self,event):
        global sobrekatamotz_abierto
        if sobrekatamotz_abierto==False:
            event_sobre_kata = MiniFrame1(frameprincipal)
            event_sobre_kata.Show()
            sobrekatamotz_abierto=True
        event.Skip()
        
    def subapareciendo(self,event):
        Texto.desapareciendo=False
        self.refrescarpagina(0,Texto.indiceletras,len(Texto.lin[Texto.indicelin]))
        event.Skip()

    def subnormalizarbusquedas(self,event):
        Texto.sinacentomin2 = Texto.sinacentomin(self.text_ctrl_2.GetValue())
        Texto.sinacentomin3 = Texto.sinacentomin(self.text_ctrl_3.GetValue())
        Texto.sinacentomin4 = Texto.sinacentomin(self.text_ctrl_4.GetValue())
        Texto.sinacentomin5 = Texto.sinacentomin(self.text_ctrl_5.GetValue())
 
    def subdesapareciendo(self,event):
        Texto.desapareciendo=True
        self.refrescarpagina(0,Texto.indiceletras,len(Texto.lin[Texto.indicelin]))
        event.Skip()
        
    def colorealetras (self,puntfinaliza,puntempieza):
        listabusquedas=[Texto.sinacentomin2,Texto.sinacentomin3,Texto.sinacentomin4,Texto.sinacentomin5]
        listacolores=["Red",wx.Colour(100,100,100),"Green","Brown"]
        parrafoactual=Texto.linsinacentomin [Texto.indicelin]
        i=0
        for busqueda in listabusquedas:
            numero=parrafoactual.count(busqueda,puntempieza,puntfinaliza)
            if numero>0:
                pos=puntempieza-1
                for j in range(0,numero):
                    pos = parrafoactual.find(busqueda, pos+1, puntfinaliza)
                    if pos==-1: break  # no ha encontrado palabra (subcadena)en el elemento
                    self.text_ctrl_1.SetStyle (pos+len(busqueda),pos,wx.TextAttr(listacolores[i],"white"))
            i+=1
                 
         
        
    def refrescarpaginatimer(self,inicio,medio,fin):
        if Texto.desapareciendo:
            if fin-medio>30: fin=medio+30
            if medio>30: inicio=medio-20
            self.text_ctrl_1.SetStyle (medio,inicio,wx.TextAttr("white","white"))
            self.colorealetras(fin,medio)
            
        else:
            if medio-inicio>30: inicio=medio-30
            if medio>30: inicio=medio-20
            self.text_ctrl_1.SetStyle (medio,inicio,wx.TextAttr("blue","white"))
            self.colorealetras(medio,inicio)
            
    def refrescarpagina(self,inicio,medio,fin):
    
        if Texto.desapareciendo:
            self.text_ctrl_1.SetStyle (medio,inicio,wx.TextAttr("white","white"))
            self.text_ctrl_1.SetStyle (fin,medio,wx.TextAttr("blue","white"))
            if fin-medio>30: fin=medio+30
            self.colorealetras(fin,medio)
            
        else:
            self.text_ctrl_1.SetStyle (fin,medio,wx.TextAttr("white","white"))
            self.text_ctrl_1.SetStyle (medio,inicio,wx.TextAttr("blue","white"))
            if medio-inicio>30: inicio=medio-30
            self.colorealetras(medio,inicio)
            
        
                
    def subarial(self, event): # wxGlade: MyFrame.<event_handler>
        Texto.fuente="Arial"     
        self.text_ctrl_1.SetFont(wx.Font(self.slider_1.GetValue()*2+15, wx.DEFAULT, wx.NORMAL, wx.NORMAL,0 , "Liberation Sans"))
        self.refrescarpagina(0,Texto.indiceletras,len(Texto.lin[Texto.indicelin]))
        event.Skip()

    def subligada(self, event): # wxGlade: MyFrame.<event_handler>
        Texto.fuente= "Edelfontmed"
        self.text_ctrl_1.SetFont(wx.Font(self.slider_1.GetValue()*2+15, wx.DEFAULT, wx.NORMAL, wx.NORMAL, 0, "Edelfontmed"))
        self.refrescarpagina(0,Texto.indiceletras,len(Texto.lin[Texto.indicelin]))
        event.Skip()

    def submono(self, event): # wxGlade: MyFrame.<event_handler>
        Texto.fuente= "Courier New"
        self.text_ctrl_1.SetFont(wx.Font(self.slider_1.GetValue()*2+15, wx.DEFAULT, wx.NORMAL, wx.NORMAL, 0, "Liberation Mono"))
        self.refrescarpagina(0,Texto.indiceletras,len(Texto.lin[Texto.indicelin]))
        event.Skip()

    
    def onpause(self,event):
        global pausar
        pausar= True
        self.text_ctrl_1.SetFocus()
        event.Skip()
    
    def onatras(self, event): # wxGlade: MyFrame.<event_handler>
        global empezar,pausar
        
        pausar= True
        if Texto.indicepalabras>0:
            Texto.indicepalabras-=1
            Texto.indiceletras-=len(Texto.listapalabras[Texto.indicepalabras])+1
            self.refrescarpagina(0,Texto.indiceletras,len(Texto.lin[Texto.indicelin]))
            self.timer.Stop()    
        else:
            if Texto.indicelin>0:
                Texto.indicelin-=1 
                Texto.listapalabras=Texto.lin[Texto.indicelin].split(" ")
                Texto.numeropalabras=len(Texto.listapalabras)
                Texto.indiceletras=len(Texto.lin[Texto.indicelin])-len(Texto.listapalabras[Texto.indicepalabras-1])
                Texto.indicepalabras=Texto.numeropalabras-1
                self.text_ctrl_1.SetValue(Texto.lin[Texto.indicelin])
                self.refrescarpagina(0,Texto.indiceletras,len(Texto.lin[Texto.indicelin]))
        
        event.Skip()

    def onplay(self, event):
        global empezar,pausar
        empezar= True
        pausar= False
        Texto.numeropalabras=len (Texto.listapalabras)
        Texto.listapalabras=Texto.lin[Texto.indicelin].split(" ")
        self.refrescarpagina(0,Texto.indiceletras,len(Texto.lin[Texto.indicelin]))
        self.timer.Stop()
        self.timer.Start(3100-(self.slider_2.GetValue()*30))
        self.text_ctrl_1.SetInsertionPoint(Texto.indiceletras)
        self.text_ctrl_1.Enable(False)
        
        event.Skip()
        
    def OnClose(self,event):
        self.timer.Stop()
        self.Destroy()
        event.Skip()
        
    def onstop(self, event):
        global pausar,empezar
        Texto.indiceletras=0
        Texto.indicelin=0
        Texto.indicepalabras=0
        Texto.numeropalabras=len(Texto.listapalabras)
        Texto.listapalabras=Texto.lin[Texto.indicelin].split(" ")
        self.text_ctrl_1.SetValue(Texto.lin[Texto.indicelin])
        self.refrescarpagina(0,0,len(Texto.lin[Texto.indicelin]))
        empezar= False
        pausar= False
        self.timer.Stop()
        self.text_ctrl_1.Enable(False)
        
        event.Skip()
        

    def ondelante(self, event):
        global empezar,pausar
        if Texto.indiceletras<len(Texto.lin[Texto.indicelin]):
            Texto.indiceletras+=len(Texto.listapalabras[Texto.indicepalabras])+1
            Texto.indicepalabras+=1
            #self.text_ctrl_1.SetValue(Texto.lin[Texto.indicelin])
            self.refrescarpagina(0,Texto.indiceletras,len(Texto.lin[Texto.indicelin]))
            self.timer.Stop()
            pausar= True
        else:
            if Texto.indicelin<Texto.numerolin:
                Texto.indicepalabras=0
                Texto.indicelin+=1
                Texto.indiceletras=0
                Texto.numeropalabras=len(Texto.listapalabras)
                Texto.listapalabras=Texto.lin[Texto.indicelin].split(" ")
                self.text_ctrl_1.SetValue(Texto.lin[Texto.indicelin])
                self.refrescarpagina (0,Texto.indiceletras,len(Texto.lin[Texto.indicelin]))
                self.timer.Stop()
                pausar= True
        
        event.Skip()

    
    def onTimer(self,event):
        global empezar,pausar,retraso

        retraso-=4
        if retraso<1:
            if (empezar) and (Texto.indicepalabras<len(Texto.listapalabras)) and (not pausar):
                Texto.indiceletras+=len (Texto.listapalabras[Texto.indicepalabras])+1
                if Texto.indicepalabras+1<Texto.numeropalabras:
                    if Texto.desapareciendo:
                        retraso=len (Texto.listapalabras[Texto.indicepalabras+1])+1
                    else: 
                        retraso=len (Texto.listapalabras[Texto.indicepalabras])+1
                else:
                    retraso=len (Texto.listapalabras[Texto.indicepalabras])+1
                Texto.indicepalabras+=1
                self.refrescarpaginatimer (0,Texto.indiceletras,len(Texto.lin[Texto.indicelin]))
            else:
                if (Texto.indicepalabras>=len(Texto.listapalabras)) and (Texto.indicelin<Texto.numerolin):
                    Texto.indiceletras=0
                    Texto.indicepalabras=0
                    Texto.indicelin+=1
                    Texto.listapalabras=Texto.lin[Texto.indicelin].split(" ")
                    Texto.numeropalabras=len(Texto.listapalabras)
                    self.text_ctrl_1.SetValue(Texto.lin[Texto.indicelin])
                    self.refrescarpagina (0,Texto.indiceletras,len(Texto.lin[Texto.indicelin]))
        else:
            retraso-=2
        
        event.Skip()
    
    def subabrirarchivo(self, event):
        global empezar,pausar,abrirarchivo_abierto
        
        Texto.indicepalabras=0
        Texto.indiceletras=0
        empezar = False
        pausar = True
        frame_abrirarchivo= Frame1(frameprincipal)
        if abrirarchivo_abierto == False:
            frame_abrirarchivo.Show()
            abrirarchivo_abierto= True
        event.Skip()

    def subtamanoletra(self, event):
        self.text_ctrl_1.SetFont(wx.Font((self.slider_1.GetValue()*2)+15, wx.DEFAULT, wx.NORMAL, wx.NORMAL,0,Texto.fuente))
        self.refrescarpagina(0,Texto.indiceletras,len(Texto.lin[Texto.indicelin]))
        event.Skip()

    def subvelocidad(self, event):
        self.timer.Stop()
        self.timer.Start(3100- (self.slider_2.GetValue()*30))
        
        event.Skip()
        

# end of class MyFrame



if __name__ == "__main__":
    app = wx.PySimpleApp(0)
    wx.InitAllImageHandlers()
    frameprincipal = MyFrame(None, -1, "")
    Texto=texto()
    app.SetTopWindow(frameprincipal)
    frameprincipal.Show()
    app.MainLoop()
